/*客户端用插件方法
 */
var wiseks = {
    //返回主页或上一级
    goBack: function(succ, fail, backT, param) {
        succ = succ || null;
        fail = fail || null;
        var params = {
            'backType': backT, //1返回上一页 2返回客户端主页
            'reload': param || 0
        }
        cordova.exec(succ, fail, "ViewPlugin", "back", [params])
    },
    //跳转h5页面
    skip: function(url,rc) {
        rc = rc || '';
        cordova.exec(null, null, "ViewPlugin", "skip", [{
            "html": url,
            "readCount":rc
        }]);
    },
    //跳转h5页面，每次都打开一个新的页面
    skipWithNewView: function(url,rc) {
        rc = rc || '';
        cordova.exec(null, null, "ViewPlugin", "skipWithNewView", [{
            "html": url,
            "readCount":rc
        }]);
    },
    //跳转h5页面，打开新页面有原生标题
    skipWithNavigationBar: function(url, title,rc) {
        rc = rc || '';
        cordova.exec(null, null, "ViewPlugin", "skipWithNavigationBar", [{
            "html": url,
            "title": title,
            "readCount":rc
        }]);
    },
    //跳转第三方页面地址
    skipToSpecialView: function(url, title) {
        cordova.exec(null, null, "ViewPlugin", "skipToSpecialView", [{
            "html": url,
            "title": title
        }]);
    },
    //站点中打开zip包首页
    skipToModuleIndexPage: function(code, url) {
        var param = {};
        param.code = code; //模块code
        param.url = url; //相对路径
        cordova.exec(null, null, "ViewPlugin", "skipToModuleIndexPage", [param]);
    },
    //有原生标题，总是跳转到一个新页面
    skipWithNewNavigationBar: function(url, title,rc) {
        rc = rc || '';
        cordova.exec(null, null, "ViewPlugin", "skipWithNewNavigationBar", [{
            "html": url, //页面地址
            "title": title, //标题
            "readCount":rc
        }]);
    },

    //弹框
    showAlertView1: function(msg, tit) {
        msg = msg || '';
        tit = tit || '提示';
        var param = {};
        param.message = msg;
        param.title = tit;
        param.type = '1';
        cordova.exec(null, null, 'ViewPlugin', 'showAlertView', [param]);
    },
    //确认框-有确定取消按钮
    showAlertView2: function(succ, fail, msg, tit) {
        succ = succ || null;
        fail = fail || null;
        msg = msg || '';
        tit = tit || '提示';
        var param = {};
        param.message = msg;
        param.title = tit;
        param.type = '2';
        cordova.exec(succ, fail, 'ViewPlugin', 'showAlertView', [param]);
    },
    //获取用户信息-基本信息
    getUserInfo: function(succ, fail) {
        cordova.exec(succ, fail, "UserPlugin", "getUserInfo", []);
    },
    //获取用户个人信息
    getNewUserInfo: function(succ, fail, params) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, 'UserPlugin', 'getNewUserInfo', [params]);
    },
    //获取用户基础信息20191022
    fetchBaseUserInfo: function(succ, fail, params) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, 'UserPlugin', 'fetchBaseUserInfo', [params]);
    },
    //获取用户实名信息-智慧昆山20200311 v6.5
    fetchRealPersonInfoForZHKS: function(succ, fail, params) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, 'UserPlugin', 'fetchRealPersonInfoForZHKS', [params]);
    },
    //获取用户实名信息-行政审批20200311 v6.5
    fetchRealPersonInfoForXZSP: function(succ, fail, params) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, 'UserPlugin', 'fetchRealPersonInfoForXZSP', [params]);
    },
    //获取用户完整信息(包括教育绑定和机顶盒绑定)20191022
    fetchAllUserInfo: function(succ, fail, params) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, 'UserPlugin', 'fetchAllUserInfo', [params]);
    },
    //进入个人中心
    enterUserCenter: function(succ, fail, param) {
        succ = succ || null;
        fail = fail || null;
        var params = {
            'type': param
        }
        cordova.exec(succ, fail, 'UserPlugin', 'enterUserCenter', [params]);
    },
    //判断用户是否登录e
    isLogin: function(succ, fail) {
        cordova.exec(succ, fail, 'UserPlugin', 'isLogin', []);
    },
    //获取app当前版本号
    appVersion: function(succ, fail) {
        cordova.exec(succ, fail, 'UserPlugin', 'appVersion', []);
    },
    //分享
    share: function(succ, fail, type, title, descr, thumImage, shareUrl) {
        succ = succ || null;
        fail = fail || null;
        var param = {
            "type": type,
            "title": title,
            "descr": descr,
            "thumImage": thumImage,
            "url": shareUrl
        };
        cordova.exec(succ, fail, 'SocialPlugin', 'share', [param]);
    },
    //打电话
    call: function(phoneNum) {
        cordova.exec(null, null, "SocialPlugin", "call", [{
            "phoneNumber": phoneNum
        }]);
    },
    //选取和上传图片
    chooseAndUploadPhotos: function(succ, fail, maxSelections, sorting, width, maxSize) {
        succ = succ || null;
        fail = fail || null;
        var param = {
            "maxSelections": maxSelections, //最大选取数
            "sorting": sorting, //返回值是否有序-1有序
            "width": width, //压缩后的宽度,同maxSize一起使用
            "maxSize": maxSize //图片文件的最终大小
        };
        cordova.exec(succ, fail, 'CameraPlugin', 'chooseAndUploadPhotos', [param]);
    },
    //扫描二维码
    scan: function(succ, fail) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, 'CameraPlugin', 'scan', []);
    },
    //截屏，
    webViewSnapshot: function(succ, fail) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, 'CameraPlugin', 'webViewSnapshot', []);
    },
    //跳转资讯/帖子详情页面
    skipToNewsDetailView: function(succ, fail, newsId, newsTag, newsTag, newsTag) {
        succ = succ || null;
        fail = fail || null;
        var params = {
            "newsId": newsId, //帖子或新闻id
            "newsTag": newsTag, //新闻的tag
            "type": newsTag, //1-民生  2-资讯
            "canComment": newsTag //0-不可评论 1-可评论
        }
        cordova.exec(succ, fail, "ViewPlugin", "skipToNewsDetailView", [params])
    },
    //附件预览
    previewFile: function(succ, fail, viewUrl, title) {
        succ = succ || null;
        fail = fail || null;
        var params = {
            "viewUrl": viewUrl,
            "title": title
        }
        cordova.exec(succ, fail, "ViewPlugin", "previewFile", [params])
    },
    //打开视频播放器-ios/android
    videoPlay: function(succ, fail, params) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, "MediaPlugin", "videoPlay", [params])
    },
    //获取视频续看点-ios/android
    videoResumePoint: function(succ, fail) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, "MediaPlugin", "videoResumePoint", [])
    },
    //退出播放-ios/android
    exitVideo: function(succ, fail) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, "MediaPlugin", "exitVideo", [])
    },
    //视频插件-打开视频播放器-android
    play: function(succ, fail, videoUrl) {
        succ = succ || null;
        fail = fail || null;
        var params = {
            "url": videoUrl
        }
        cordova.exec(succ, fail, "MediaPlugin", "play", [params])
    },
    resume: function(succ, fail) { //暂停恢复播放，保留位置-android
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, "MediaPlugin", "resume", [])
    },
    pasue: function(succ, fail) { //暂停播放，视频框保留-android
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, "MediaPlugin", "pasue", [])
    },
    stop: function(succ, fail) { //退出播放，视频框会消失-android
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, "MediaPlugin", "stop", [])
    },
    onBackPress: function(succ, fail) { //返回,用于H5判断用户点击物理返回键之后的处理-android
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, "MediaPlugin", "onBackPress", [])
    },
    //获取经纬度
    getCurrentLocation: function(succ, fail) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, "MapPlugin", "getCurrentLocation", [])
    },
    //调用支付1-客户安装建行手机银行或者未安装均可完成支付
    payOrder: function(succ, fail, param) {
        cordova.exec(succ, fail, 'PayPlugin', 'payOrder', [param]);
    },
    //调用支付2-只是用app支付
    payAppOrder: function(succ, fail, param) {
        cordova.exec(succ, fail, 'PayPlugin', 'payAppOrder', [param]);
    },
    //调用支付3-直接弹出H5支付
    payUrlOrder: function(succ, fail, param) {
        cordova.exec(succ, fail, 'PayPlugin', 'payUrlOrder', [param]);
    },
    //图片保存
    saveImageToAlbum: function(succ, fail, picUrl) {
        succ = succ || null;
        fail = fail || null;
        var params = {
            "url": picUrl
        }
        cordova.exec(succ, fail, "CameraPlugin", "saveImageToAlbum", [params])
    },
    //视频下载
    saveVideoToAlbum: function(succ, fail, videoUrl) {
        succ = succ || null;
        fail = fail || null;
        var params = {
            "url": videoUrl
        }
        cordova.exec(succ, fail, "CameraPlugin", "saveVideoToAlbum", [params])
    },
    //请求用户一段时间内的运动步数
    requestStepCount: function(succ, fail, param) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, 'SportPlugin', 'requestStepCount', [param]);
    },
    //打开webview，状态栏可自定义
    adaptWebView: function(succ, fail, param) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, 'ViewPlugin', 'adaptWebView', [param]);
    },
    //打开原生代码-微课
    skipToWeiKePage: function(succ, fail) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, 'ViewPlugin', 'skipToWeiKePage', []);
    },
    //请求茁壮接口，并返回结果数据
    requestIPanel: function(succ, fail, params) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, 'STBPlugin', 'requestIPanel', [params]);
    },
    //获取教育绑定列表-优先缓存中取
    getThirdpartyBindList: function(succ, fail, params) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, 'UserPlugin', 'getThirdpartyBindList', []);
    },
    //获取机顶盒绑定列表-优先缓存中取
    getIPanelBindList: function(succ, fail, params) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, 'STBPlugin', 'getIPanelBindList', [params]);
    },
    //录音-黄金屋
    takePicture: function(succ, fail, params) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, 'Camera', 'takePicture', [params]);
    },
    //拍照
    showTakePhotoView: function(succ, fail, params) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, 'TakePhotoPlugin', 'showTakePhotoView', [params]);
    },
    //图片上传
    uploadPhoto: function(succ, fail, params) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, 'TakePhotoPlugin', 'uploadPhoto', [params]);
    },
    //
    testSaveLocationExists: function(succ, fail, params) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, 'File', 'testSaveLocationExists', [params]);
    },
    openShareWebView: function(succ, fail, params) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, 'ViewPlugin', 'openShareWebView', [params]);
    },
    //营业执照识别
    recognizeLicence: function(succ, fail, params) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, 'CameraPlugin', 'recognizeLicence', [params]);
    },
    //手机电视支付
    tvPay: function(succ, fail, params) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, 'PayPlugin', 'tvPay', [params]);
    },
    //获取我的电视终端绑定列表（营业厅）
    getTVBindList: function(succ, fail, params) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, 'UserPlugin', 'getTVBindList', [params]);
    },
    //绑定第三方用户信息
    bindThirdInfo: function(succ, fail, params) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, 'UserPlugin', 'bindThirdInfo', [params]);
    },
    //教育缴费-只android
    EduWeb: function(succ, fail, params) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, 'EduWebPlugin', 'EduWeb', [params]);
    },
    // 调用添加信用卡申请信息接口
    applyCreditCard: function(succ, fail, params) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, 'KRCBPlugin', 'applyCreditCard', [params]);
    },
    //扫描条形码
    brCodeScan: function(succ, fail) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, 'CameraPlugin', 'brCodeScan', []);
    },
    //打开地图应用-路线规划
    openMapApp: function(succ, fail, params) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, 'MapPlugin', 'openMapApp', [params]);
    },
    //添加桌面快捷方式
    addShortCut: function(succ, fail, params) {
        succ = succ || null;
        fail = fail || null;
        cordova.exec(succ, fail, 'ShortCutPlugin', 'addShortCut', [params]);
    }
}

//检测插件是否存在
function isExitsPlugin(pluginName) {
    try {
        if (typeof(wiseks) != 'undefined' && typeof(eval(pluginName)) == "function") {
            return true;
        }
    } catch (e) {}
    return false;
}
