/*! think2 v1.0.1 | @author zhoubin */
(function () {
    'use strict';

    /**
     * wiseks公用对象，提供插件方法
     */
    function Wiseks() {
        this.version = "1.0.1";
    }

    /**
     * 检测插件是否存在
     * @param name 插件名称
     * @returns{Boolean} 是否存在
     */
    Wiseks.prototype.canIUse = function (name) {
        let _plugins = ['goBack', 'skip'];
        // try {
        //     if (typeof(wiseks) != 'undefined' && typeof(eval(pluginName)) == "function") {
        //         return true;
        //     }
        // } catch (e) {
        // }
        return _plugins.indexOf(name) >= 0;
    };

    /**
     * 返回主页或上一级
     * @param success 成功回调
     * @param fail 失败回调
     * @param backT 1返回上一页 2返回客户端主页
     * @param reload
     */
    Wiseks.prototype.goBack = function (success, fail, backT, reload) {
        cordova.exec(success || null, fail || null, "ViewPlugin", "back", [{
            'backType': backT, //1返回上一页 2返回客户端主页
            'reload': reload || 0
        }]);
    };

    /**
     * 跳转h5页面
     * @param url 页面地址
     * @param rc
     */
    Wiseks.prototype.skip = function (url, rc) {
        cordova.exec(null, null, "ViewPlugin", "skip", [{
            "html": url,
            "readCount": rc || ''
        }]);
    };

    /**
     * 跳转h5页面，每次都打开一个新的页面
     * @param url 页面地址
     * @param rc
     */
    Wiseks.prototype.skipWithNewView = function (url, rc) {
        cordova.exec(null, null, "ViewPlugin", "skipWithNewView", [{
            "html": url,
            "readCount": rc || ''
        }]);
    };

    /**
     * 跳转h5页面，打开新页面有原生标题
     * @param url 页面地址
     * @param title 页面标题
     * @param rc
     */
    Wiseks.prototype.skipWithNavigationBar = function (url, title, rc) {
        cordova.exec(null, null, "ViewPlugin", "skipWithNavigationBar", [{
            "html": url,
            "title": title,
            "readCount": rc || ''
        }]);
    };

    /**
     * 返回是否具有原生标题
     */
    Wiseks.prototype.hasClientHeader = function (success, fail) {
        cordova.exec(success || null, fail || null, "ViewPlugin", "hasClientHeader", []);
    };

    /**
     * 跳转第三方页面地址
     * @param url 页面地址
     * @param title 页面标题
     */
    Wiseks.prototype.skipToSpecialView = function (url, title) {
        cordova.exec(null, null, "ViewPlugin", "skipToSpecialView", [{
            "html": url,
            "title": title
        }]);
    };

    /**
     * 站点中打开zip包首页
     * @param code 模块code
     * @param url 相对路径
     */
    Wiseks.prototype.skipToModuleIndexPage = function (code, url) {
        cordova.exec(null, null, "ViewPlugin", "skipToModuleIndexPage", [{
            "code": code,
            "url": url
        }]);
    };

    /**
     * 有原生标题，总是跳转到一个新页面
     * @param url 页面地址
     * @param title 标题
     * @param rc
     */
    Wiseks.prototype.skipWithNewNavigationBar = function (url, title, rc) {
        rc = rc || '';
        cordova.exec(null, null, "ViewPlugin", "skipWithNewNavigationBar", [{
            "html": url, //页面地址
            "title": title, //标题
            "readCount": rc || ''
        }]);
    };

    /**
     * 弹框
     * @param msg 消息
     * @param tit 提示
     */
    Wiseks.prototype.showAlertView1 = function (msg, tit) {
        cordova.exec(null, null, 'ViewPlugin', 'showAlertView', [{
            "message": msg || '',
            "title": tit || '提示',
            "type": '1'
        }]);
    };

    /**
     * 确认框-有确定取消按钮
     * @param success 成功回调
     * @param fail 失败回调
     * @param msg 消息
     * @param tit 提示
     */
    Wiseks.prototype.showAlertView2 = function (success, fail, msg, tit) {
        cordova.exec(success || null, fail || null, 'ViewPlugin', 'showAlertView', [{
            "message": msg || '',
            "title": tit || '提示',
            "type": '2'
        }]);
    };

    /**
     * 获取用户信息-基本信息
     * @param success 成功回调
     * @param fail 失败回调
     */
    Wiseks.prototype.getUserInfo = function (success, fail) {
        cordova.exec(success || null, fail || null, "UserPlugin", "getUserInfo", []);
    };

    /**
     * 获取用户个人信息
     * @param success 成功回调
     * @param fail 失败回调
     * @param params
     */
    Wiseks.prototype.getNewUserInfo = function (success, fail, params) {
        cordova.exec(success || null, fail || null, 'UserPlugin', 'getNewUserInfo', [params]);
    };

    /**
     * 获取用户基础信息20191022
     * @param success 成功回调
     * @param fail 失败回调
     * @param params
     */
    Wiseks.prototype.fetchBaseUserInfo = function (success, fail, params) {
        success = success || null;
        fail = fail || null;
        cordova.exec(success || null, fail || null, 'UserPlugin', 'fetchBaseUserInfo', [params]);
    };

    /**
     * 获取用户实名信息-智慧昆山20200311 v6.5
     * @param success 成功回调
     * @param fail 失败回调
     * @param params
     */
    Wiseks.prototype.fetchRealPersonInfoForZHKS = function (success, fail, params) {
        success = success || null;
        fail = fail || null;
        cordova.exec(success || null, fail || null, 'UserPlugin', 'fetchRealPersonInfoForZHKS', [params]);
    };

    /**
     * 获取用户实名信息-行政审批20200311 v6.5
     * @param success 成功回调
     * @param fail 失败回调
     * @param params
     */
    Wiseks.prototype.fetchRealPersonInfoForXZSP = function (success, fail, params) {
        success = success || null;
        fail = fail || null;
        cordova.exec(success || null, fail || null, 'UserPlugin', 'fetchRealPersonInfoForXZSP', [params]);
    };

    /**
     * 获取用户完整信息(包括教育绑定和机顶盒绑定)20191022
     * @param success 成功回调
     * @param fail 失败回调
     * @param params
     */
    Wiseks.prototype.fetchAllUserInfo = function (success, fail, params) {
        success = success || null;
        fail = fail || null;
        cordova.exec(success || null, fail || null, 'UserPlugin', 'fetchAllUserInfo', [params]);
    };

    /**
     * 进入个人中心
     * @param success 成功回调
     * @param fail 失败回调
     * @param param
     */
    Wiseks.prototype.enterUserCenter = function (success, fail, param) {
        cordova.exec(success || null, fail || null, 'UserPlugin', 'enterUserCenter', [{
            'type': param
        }]);
    };

    /**
     * 判断用户是否登录
     * @param success 成功回调
     * @param fail 失败回调
     */
    Wiseks.prototype.isLogin = function (success, fail) {
        cordova.exec(success || null, fail || null, 'UserPlugin', 'isLogin', []);
    };

    /**
     * 获取app当前版本号
     * @param success 成功回调
     * @param fail 失败回调
     */
    Wiseks.prototype.appVersion = function (success, fail) {
        cordova.exec(success || null, fail || null, 'UserPlugin', 'appVersion', []);
    };

    /**
     * 获取app的相关信息
     * @param success 成功回调
     */
    Wiseks.prototype.appInfo = function (success) {
        cordova.exec(success || null, null, 'UserPlugin', 'appInfo', []);
    };

    /**
     * 分享
     * @param success 成功回调
     * @param fail 失败回调
     * @param type
     * @param title
     * @param descr
     * @param thumImage
     * @param shareUrl
     */
    Wiseks.prototype.share = function (success, fail, type, title, descr, thumImage, shareUrl) {
        cordova.exec(success || null, fail || null, 'SocialPlugin', 'share', [{
            "type": type,
            "title": title,
            "descr": descr,
            "thumImage": thumImage,
            "url": shareUrl
        }]);
    };

    /**
     * 打电话
     * @param phoneNum 电话号码
     */
    Wiseks.prototype.call = function (phoneNum) {
        cordova.exec(null, null, "SocialPlugin", "call", [{
            "phoneNumber": phoneNum
        }]);
    };

    /**
     * 选取和上传图片
     * @param success 成功回调
     * @param fail 失败回调
     * @param maxSelections 最大选取数
     * @param sorting 返回值是否有序-1有序
     * @param width 压缩后的宽度,同maxSize一起使用
     * @param maxSize 图片文件的最终大小
     */
    Wiseks.prototype.chooseAndUploadPhotos = function (success, fail, maxSelections, sorting, width, maxSize) {
        cordova.exec(success || null, fail || null, 'CameraPlugin', 'chooseAndUploadPhotos', [{
            "maxSelections": maxSelections, //最大选取数
            "sorting": sorting, //返回值是否有序-1有序
            "width": width, //压缩后的宽度,同maxSize一起使用
            "maxSize": maxSize //图片文件的最终大小
        }]);
    };

    /**
     * 扫描二维码
     * @param success 成功回调
     * @param fail 失败回调
     */
    Wiseks.prototype.scan = function (success, fail) {
        cordova.exec(success || null, fail || null, 'CameraPlugin', 'scan', []);
    };

    /**
     * 截屏
     * @param success 成功回调
     * @param fail 失败回调
     */
    Wiseks.prototype.webViewSnapshot = function (success, fail) {
        cordova.exec(success || null, fail || null, 'CameraPlugin', 'webViewSnapshot', []);
    };

    /**
     * 跳转资讯/帖子详情页面
     * @param success 成功回调
     * @param fail 失败回调
     * @param newsId 帖子或新闻id
     * @param newsTag 新闻的tag
     * @param newsTag 1-民生  2-资讯
     * @param newsTag 0-不可评论 1-可评论
     */
    Wiseks.prototype.skipToNewsDetailView = function (success, fail, newsId, newsTag, type, canComment) {
        cordova.exec(success || null, fail || null, "ViewPlugin", "skipToNewsDetailView", [{
            "newsId": newsId, //帖子或新闻id
            "newsTag": newsTag, //新闻的tag
            "type": type, //1-民生  2-资讯
            "canComment": canComment //0-不可评论 1-可评论
        }]);
    };

    /**
     * 附件预览
     * @param success 成功回调
     * @param fail 失败回调
     * @param viewUrl
     * @param title
     */
    Wiseks.prototype.previewFile = function (success, fail, viewUrl, title) {
        cordova.exec(success || null, fail || null, "ViewPlugin", "previewFile", [{
            "viewUrl": viewUrl,
            "title": title
        }]);
    };

    /**
     * 打开视频播放器-ios/android
     * @param success 成功回调
     * @param fail 失败回调
     * @param params
     */
    Wiseks.prototype.videoPlay = function (success, fail, params) {
        cordova.exec(success || null, fail || null, "MediaPlugin", "videoPlay", [params]);
    };

    /**
     * 获取视频续看点-ios/android
     * @param success 成功回调
     * @param fail 失败回调
     */
    Wiseks.prototype.videoResumePoint = function (success, fail) {
        cordova.exec(success || null, fail || null, "MediaPlugin", "videoResumePoint", []);
    };

    /**
     * 退出播放-ios/android
     * @param success 成功回调
     * @param fail 失败回调
     */
    Wiseks.prototype.exitVideo = function (success, fail) {
        cordova.exec(success || null, fail || null, "MediaPlugin", "exitVideo", []);
    };

    /**
     * 视频插件-打开视频播放器-android
     * @param success 成功回调
     * @param fail 失败回调
     * @param videoUrl
     */
    Wiseks.prototype.play = function (success, fail, videoUrl) {
        cordova.exec(success || null, fail || null, "MediaPlugin", "play", [{
            "url": videoUrl
        }]);
    };

    /**
     * 暂停恢复播放，保留位置-android
     * @param success 成功回调
     * @param fail 失败回调
     */
    Wiseks.prototype.resume = function (success, fail) {
        cordova.exec(success || null, fail || null, "MediaPlugin", "resume", []);
    };

    /**
     * 暂停播放，视频框保留-android
     * @param success 成功回调
     * @param fail 失败回调
     */
    Wiseks.prototype.pasue = function (success, fail) {
        cordova.exec(success || null, fail || null, "MediaPlugin", "pasue", []);
    };

    /**
     * 退出播放，视频框会消失-android
     * @param success 成功回调
     * @param fail 失败回调
     */
    Wiseks.prototype.stop = function (success, fail) {
        cordova.exec(success || null, fail || null, "MediaPlugin", "stop", []);
    };

    /**
     * 返回,用于H5判断用户点击物理返回键之后的处理-android
     * @param success 成功回调
     * @param fail 失败回调
     */
    Wiseks.prototype.onBackPress = function (success, fail) {
        cordova.exec(success || null, fail || null, "MediaPlugin", "onBackPress", []);
    };

    /**
     * 获取经纬度
     * @param success 成功回调
     * @param fail 失败回调
     */
    Wiseks.prototype.getCurrentLocation = function (success, fail) {
        cordova.exec(success || null, fail || null, "MapPlugin", "getCurrentLocation", []);
    };

    /**
     * 调用支付1-客户安装建行手机银行或者未安装均可完成支付
     * @param success 成功回调
     * @param fail 失败回调
     * @param param
     */
    Wiseks.prototype.payOrder = function (success, fail, param) {
        cordova.exec(success || null, fail || null, 'PayPlugin', 'payOrder', [param]);
    };

    /**
     * 调用支付2-只是用app支付
     * @param success 成功回调
     * @param fail 失败回调
     * @param param
     */
    Wiseks.prototype.payAppOrder = function (success, fail, param) {
        cordova.exec(success || null, fail || null, 'PayPlugin', 'payAppOrder', [param]);
    };

    /**
     * 调用支付3-直接弹出H5支付
     * @param success 成功回调
     * @param fail 失败回调
     * @param param
     */
    Wiseks.prototype.payUrlOrder = function (success, fail, param) {
        cordova.exec(success || null, fail || null, 'PayPlugin', 'payUrlOrder', [param]);
    };

    /**
     * 图片保存
     * @param success 成功回调
     * @param fail 失败回调
     * @param picUrl 图片地址
     */
    Wiseks.prototype.saveImageToAlbum = function (success, fail, picUrl) {
        cordova.exec(success || null, fail || null, "CameraPlugin", "saveImageToAlbum", [{
            "url": picUrl
        }]);
    };

    /**
     * 视频下载
     * @param success 成功回调
     * @param fail 失败回调
     * @param videoUrl
     */
    Wiseks.prototype.saveVideoToAlbum = function (success, fail, videoUrl) {
        cordova.exec(success || null, fail || null, "CameraPlugin", "saveVideoToAlbum", [{
            "url": videoUrl
        }]);
    };

    /**
     * 请求用户一段时间内的运动步数
     * @param success 成功回调
     * @param fail 失败回调
     * @param param
     */
    Wiseks.prototype.requestStepCount = function (success, fail, param) {
        cordova.exec(success || null, fail || null, 'SportPlugin', 'requestStepCount', [param]);
    };

    /**
     * 打开webview，状态栏可自定义
     * @param success 成功回调
     * @param fail 失败回调
     * @param param
     */
    Wiseks.prototype.adaptWebView = function (success, fail, param) {
        cordova.exec(success || null, fail || null, 'ViewPlugin', 'adaptWebView', [param]);
    };

    /**
     * 打开原生代码-微课
     * @param success 成功回调
     * @param fail 失败回调
     */
    Wiseks.prototype.skipToWeiKePage = function (success, fail) {
        cordova.exec(success || null, fail || null, 'ViewPlugin', 'skipToWeiKePage', []);
    };

    /**
     * 请求茁壮接口，并返回结果数据
     * @param success 成功回调
     * @param fail 失败回调
     * @param params
     */
    Wiseks.prototype.requestIPanel = function (success, fail, params) {
        cordova.exec(success || null, fail || null, 'STBPlugin', 'requestIPanel', [params]);
    };

    /**
     * 获取教育绑定列表-优先缓存中取
     * @param success 成功回调
     * @param fail 失败回调
     * @param params
     */
    Wiseks.prototype.getThirdpartyBindList = function (success, fail, params) {
        cordova.exec(success || null, fail || null, 'UserPlugin', 'getThirdpartyBindList', []);
    };

    /**
     * 获取机顶盒绑定列表-优先缓存中取
     * @param success 成功回调
     * @param fail 失败回调
     * @param params
     */
    Wiseks.prototype.getIPanelBindList = function (success, fail, params) {
        cordova.exec(success || null, fail || null, 'STBPlugin', 'getIPanelBindList', [params]);
    };

    /**
     * 录音-黄金屋
     * @param success 成功回调
     * @param fail 失败回调
     * @param params
     */
    Wiseks.prototype.takePicture = function (success, fail, params) {
        cordova.exec(success || null, fail || null, 'Camera', 'takePicture', [params]);
    };

    /**
     * 拍照
     * @param success 成功回调
     * @param fail 失败回调
     * @param params
     */
    Wiseks.prototype.showTakePhotoView = function (success, fail, params) {
        cordova.exec(success || null, fail || null, 'TakePhotoPlugin', 'showTakePhotoView', [params]);
    };

    /**
     * 图片上传
     * @param success 成功回调
     * @param fail 失败回调
     * @param params
     */
    Wiseks.prototype.uploadPhoto = function (success, fail, params) {
        cordova.exec(success || null, fail || null, 'TakePhotoPlugin', 'uploadPhoto', [params]);
    };

    /**
     *
     * @param success 成功回调
     * @param fail 失败回调
     * @param params
     */
    Wiseks.prototype.testSaveLocationExists = function (success, fail, params) {
        cordova.exec(success || null, fail || null, 'File', 'testSaveLocationExists', [params]);
    };

    /**
     *
     * @param success 成功回调
     * @param fail 失败回调
     * @param params
     */
    Wiseks.prototype.openShareWebView = function (success, fail, params) {
        cordova.exec(success || null, fail || null, 'ViewPlugin', 'openShareWebView', [params]);
    };

    /**
     * 营业执照识别
     * @param success 成功回调
     * @param fail 失败回调
     * @param params
     */
    Wiseks.prototype.recognizeLicence = function (success, fail, params) {
        cordova.exec(success || null, fail || null, 'CameraPlugin', 'recognizeLicence', [params]);
    };

    /**
     * 手机电视支付
     * @param success 成功回调
     * @param fail 失败回调
     * @param params
     */
    Wiseks.prototype.tvPay = function (success, fail, params) {
        cordova.exec(success || null, fail || null, 'PayPlugin', 'tvPay', [params]);
    };

    /**
     * 支付宝支付
     */
    Wiseks.prototype.aliPay = function (success, fail, params) {
        cordova.exec(success || null, fail || null, 'PayPlugin', 'aliPay', [params]);
    };

    /**
     * 微信支付
     */
    Wiseks.prototype.wxPay = function(success, fail, params) {
        cordova.exec(success || null, fail || null, 'PayPlugin', 'wxPay', [params]);
    };

    /**
     * 获取我的电视终端绑定列表（营业厅）
     * @param success 成功回调
     * @param fail 失败回调
     * @param params
     */
    Wiseks.prototype.getTVBindList = function (success, fail, params) {
        cordova.exec(success || null, fail || null, 'UserPlugin', 'getTVBindList', [params]);
    };

    /**
     * 绑定第三方用户信息
     * @param success 成功回调
     * @param fail 失败回调
     * @param params
     */
    Wiseks.prototype.bindThirdInfo = function (success, fail, params) {
        cordova.exec(success || null, fail || null, 'UserPlugin', 'bindThirdInfo', [params]);
    };

    /**
     * 教育缴费-只android
     * @param success 成功回调
     * @param fail 失败回调
     * @param params
     * @constructor
     */
    Wiseks.prototype.EduWeb = function (success, fail, params) {
        cordova.exec(success || null, fail || null, 'EduWebPlugin', 'EduWeb', [params]);
    };

    /**
     * 调用添加信用卡申请信息接口
     * @param success 成功回调
     * @param fail 失败回调
     * @param params
     */
    Wiseks.prototype.applyCreditCard = function (success, fail, params) {
        cordova.exec(success || null, fail || null, 'KRCBPlugin', 'applyCreditCard', [params]);
    };

    /**
     * 扫描条形码
     * @param success 成功回调
     * @param fail 失败回调
     */
    Wiseks.prototype.brCodeScan = function (success, fail) {
        cordova.exec(success || null, fail || null, 'CameraPlugin', 'brCodeScan', []);
    };

    /**
     * 打开地图应用-路线规划
     * @param success 成功回调
     * @param fail 失败回调
     * @param params
     */
    Wiseks.prototype.openMapApp = function (success, fail, params) {
        cordova.exec(success || null, fail || null, 'MapPlugin', 'openMapApp', [params]);
    };

    /**
     * 添加桌面快捷方式
     * @param success 成功回调
     * @param fail 失败回调
     * @param params
     */
    Wiseks.prototype.addShortCut = function (success, fail, params) {
        cordova.exec(success || null, fail || null, 'ShortCutPlugin', 'addShortCut', [params]);
    };

    window.wiseks = new Wiseks();

})();
